/***
 * $Source: /usr/home/ldl/langs/fm/RCS/misc.c,v $
 * $Revision: 0.19980909 $ $Date: 1998/09/09 20:46:28 $
 */

/**
 * FM - Femto-M[UMPS].
 * A number of small routines that
 * don't go anywhere else.
 */

#include "fm.h"

void
diag(str)						/* Function	*/
	char   *str;
{
	fprintf(stderr, "ERROR: %s\n", str);
	/* freecline() */
} /* diag */

void
fatal(str)						/* Function	*/
	char   *str;
{
	fprintf(stderr, "FATAL: %s\n", str);
	exit( 1 );
} /* fatal */

char *
str2upper(upper, mixed)					/* Function	*/
	char   *upper;
	char   *mixed;
{
	char	ch, *s = upper;

	while ((ch = *mixed++)) {
		*upper++ = islower(ch) ? toupper(ch) : ch;
	}
	*upper = ch;			/* Terminate string		*/
	return s;
} /* str2upper */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/

/**
 *	Functions dealing with routine lines (Type: Line)
 */
Line *
allocLine(ncmd)						/* Function	*/
	int	ncmd;
{
	Line   *line = (Line *)malloc( sizeof(Line) +
						ncmd * sizeof(Command));
	line->l_next = (Line *)NULL;
	line->l_tag  = (char *)NULL;
	line->l_ncmd = 0;
	return line;
} /* allocLine */

void
freeLine(line)						/* Function	*/
	Line   *line;
{
	int	cmd;
	int	ncmd = line->l_ncmd;
	Command *cp  = line->l_cmd;

	for (cmd = 0;  cmd < ncmd;  ++cmd, ++cp) {
		freeMStr(cp->cmd_postcond);
		freeMStr(cp->cmd_arg);
	}
	free(line);
} /* freeLine */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -	*/

/* End of $Source: /usr/home/ldl/langs/fm/RCS/misc.c,v $ */
